#! /bin/sh
#### INFO
# Provides:             MyNautel Client
# Required-Start:       network
# Required-Stop:        network
# Description:          Daemon for Remote Logging connects to MyNautel and pushes data.
####
#
# Author:               David Dumke
# DateCreated:          April 15, 2012
# LastModified:         May 08, 2012
# Version:              1.0
#
NAME=remoteloggingclient
DESC="Remote Logging Client"
CLIENT_PIDFILE="/var/run/mynclient_arm.pid"
CLIENT_REF_BIN="/nautel/remotelogging/mynclient_arm.bin"
CLIENT_EXE_BIN="/nautel/remotelogging/mynclient-run"
SCRIPTNAME=/etc/init.d/$NAME
do_start()
{
        PIDFILE="$CLIENT_PIDFILE"
        DAEMON="$CLIENT_EXE_BIN"
        # Compare the run version to the installed version.  Replace if necessary.
        diff $CLIENT_EXE_BIN $CLIENT_REF_BIN
        if [ "$?" -ne "0" ]; then
                # There is a version mismatch, install the new version.
                echo "Installing Remote Logging Client version: Unknown"
                cp $CLIENT_REF_BIN $CLIENT_EXE_BIN
        fi
        start-stop-daemon --start --quiet --background --nice -19 --exec $DAEMON -- -c /etc/myntl/client.conf
}
do_stop()
{
        killall -s SIGINT mynclient-run
}
case "$1" in
        start)
                echo "Starting MyNautel Client..."
                do_start
                ;;
        stop)
                echo "Stopping MyNautel Client..."
                do_stop
                ;;
        restart)
                echo "Restarting..."
                do_stop
                echo "  Client stopped."
                do_start
                echo "  done."
                ;;
        status)
                status_of_proc -p $SERVER_PIDFILE $SERVER_EXE_BIN $NAME && exit0 || e
                ;;
        *)
                echo "Usage: $SCRIPTNAME {start|stop|restart|status}" >&2
                exit 3
                ;;
esac
:
