<?php
#Version:       1.0.0.13
#Author:        David Dumke
#Date Created:  February 3, 2009
#Date last updated: Oct 21, 2011
#Modified by:   Shreyas Dhond
#Description:  Sets the timeout for the screensaver, and can also enable disable it. Screen powers down on timeout and settings take effect immediately.

//Set Function sets the timeout to the passed value

//Variables
$VERSION = '1.0.0.13';
$NAME = 'ScreenSaverConfig';
$opType = $_POST["type"];
$hours = intval($_POST["hours"]);
$minutes = intval($_POST["minutes"]);
$seconds = intval($_POST["seconds"]);
$enabled = intval($_POST["enabled"]);
$filename = "/home/nautel/.xscreensaver";
$count = 0;

//simplistic validation, maybe
$total_seconds = $hours * 3600 + $minutes * 60 + $seconds;
if ( $total_seconds < 600 || $total_seconds > 10800 )		// 10-180 minutes
{
	$hours = 0;
	$minutes = 30;
	$seconds = 0;
}

if ( $enabled != 0 && $enabled != 1 )
{
	$enabled = 1;
}

/********************************MAIN***************************************/
if($opType == 'SET')
{
    setConfig($filename);
    exit;
}
elseif($opType == 'GET')
{
    getConfig($filename);
    exit;
}
elseif($opType == 'version')
{
   getVersion();
   exit;
}
else
{
    printf("Unkown operation type: %s.", $opType);
    exit;
}

printf("Error! You should not make it to this point in the code.");
exit;
/******************************************************************************/
function getVersion()
{
    global $VERSION;
    global $NAME;

    $xmlStringToSend = "";

    $xmlStringToSend = $xmlStringToSend."<?xml version=\"1.0\" encoding=\"utf-\"?>\n";
    $xmlStringToSend = $xmlStringToSend."<ScriptInfo>\n";

    $xmlStringToSend = $xmlStringToSend."\t<Version>".$VERSION."</Version>\n";
        $xmlStringToSend = $xmlStringToSend."\t<Name>".$NAME."</Name>\n";

    $xmlStringToSend = $xmlStringToSend."</ScriptInfo>";
    printf("%s", $xmlStringToSend);
    } // END OF getVersion()
/******************************************************************************/
function setConfig($filename)
{
    global $count;
    global $hours;
    global $minutes;
    global $seconds;
    global $enabled;
    $lineToWrite = "";
    $wholeFile = "";
    
    if (!$fhConfig = fopen($filename,"r"))
    {
        echo "Error! Cannot open file '".$filename."'.";
        exit;
    }

    while(!feof($fhConfig))
    {
        $lineToWrite = fgets($fhConfig);
        if(substr($lineToWrite, 0, 8) == 'timeout:')
        {
            $count = 0;
            $lineToWrite = preg_replace_callback("/\d+/", "replace", $lineToWrite, 3);
        }
        else if((substr($lineToWrite,0,5) == 'mode:'))
        {
            if(preg_match('/blank/', $lineToWrite) && ($enabled == 0))
            {
                $lineToWrite = preg_replace('/blank/', 'off', $lineToWrite, 1);
				$enabled = 0;
            }
            else if (preg_match('/off/', $lineToWrite) && ($enabled == 1))
            {
                $lineToWrite = preg_replace('/off/', 'blank', $lineToWrite, 1);
            }
        }
	else if ((substr($lineToWrite,0,12) == 'dpmsEnabled:'))
	{
	    if(preg_match('/True/', $lineToWrite) && ($enabled == 0))
	    {
	    	$lineToWrite = preg_replace('/True/', 'False', $lineToWrite, 1);
	    }
	    else if (preg_match('/False/', $lineToWrite) && ($enabled == 1))
	    {
	        $lineToWrite = preg_replace('/False/', 'True', $lineToWrite, 1);
	    }
	}
	else if ((substr($lineToWrite,0,12) == 'dpmsSuspend:'))
	{
		$count = 0;
		$lineToWrite = preg_replace_callback("/\d+/", "replace", $lineToWrite, 3);
	}
	else if ((substr($lineToWrite,0,7) == 'splash:'))
	{
		if(preg_match('/True/', $lineToWrite))
		{
		    $lineToWrite = preg_replace('/True/', 'False', $lineToWrite, 1);
		}
	}
        $wholeFile = $wholeFile . $lineToWrite;
    }

    printf('SET Hours %s Minutes %s Seconds %s Enabled %s', $hours, $minutes, $seconds, $enabled);
    fclose($fhConfig);

    // now write the new data
    if (!$fhConfig = fopen($filename,"w"))
    {
        echo "Error! Cannot open file '".$filename."'.";
        exit;
    }

    fwrite($fhConfig, $wholeFile);
    fclose($fhConfig);

    system("xscreensaver-command -restart");

} //END OF setConfig()
/******************************************************************************/
function replace($matches)
{
  global $count;
  global $hours;
  global $minutes;
  global $seconds;
  $count++;

  if($count == 1)
    return $hours;
  else if($count == 2)
    return $minutes;
  else if($count == 3)
    return $seconds;

  return 0;
} //END OF replace()

function changeToZero($matches)
{
  return 0;
}
/******************************************************************************/
//Read the timeout from the file and passes it back
function getConfig($filename)
{
    if (!$fhConfig = fopen($filename,"r"))
    {
        echo "Error! Cannot open file '".$filename."'.";
        exit;
    }
    while(!feof($fhConfig))
    {
        $line = fgets($fhConfig);
        if(substr($line, 0, 8) == 'timeout:')
        {
            $pattern = '/\d+/';
            preg_match_all($pattern, $line, $matches);
            $hours = $matches[0][0];
            $minutes = $matches[0][1];
            $seconds = $matches[0][2];
			
			$timeout_complete = "1";
			if(strcmp($mode_complete, "1") == 0)
			{
				printf('GET Hours %s Minutes %s Seconds %s Enabled %s', $hours, $minutes, $seconds, $enabled);
				break;
			}
        }
		else if((substr($line,0,5) == 'mode:'))
		{
			$pattern = '/blank/';
			preg_match_all($pattern, $line, $matches);
			if(strcmp($matches[0][0], 'blank') == 0)
			{
				$enabled = 1;
			}
			else
			{
				$enabled = 0;
			}
			
			$mode_complete = "1";
			if(strcmp($timeout_complete,"1") == 0)
			{
				printf('GET Hours %s Minutes %s Seconds %s Enabled %s', $hours, $minutes, $seconds, $enabled);
				break;
			}
		}
        else
        {
            continue;
        }
    }
    fclose($fhConfig);
}   // END OF parseConfig()
/******************************************************************************/
?>
